Compiling and installing LyX
============================

Quick compilation guide
-----------------------

These four steps will compile, test and install LyX:

	0) Linux users beware: You need qt4 and qt4-devel packages 
	   of the same version to compile LyX.

	1) ./configure
	   configures LyX according to your system. 
	   You may have to set
           --with-qt4-dir=<path-to-your-qt4-installation>
     if the environment variable QTDIR is not set (for example,
     '--with-qt4-dir=/usr/share/qt4/'). Alternatively, you could
     install pkgconfig (the name might vary depending on your 
     distribution). 
	   See Note below if ./configure script is not present.

	2) make
	   compiles the program.

	3) src/lyx
	   runs the program so you can check it out.

	4) make install
	   will install it. You can use "make install-strip" instead
           if you want a smaller binary.


Note for Git checkouts
-----------------------------

If you have checked this out from Git, you need to have:
* automake >= 1.8
* autoconf >= 2.59c
* gettext >= 0.12
Then type "./autogen.sh" to build the needed configuration
files and proceed as stated above/below.

You will also probably need GNU m4 (perhaps installed as gm4).


Requirements
------------

First of all, you will also need a recent C++ compiler, where recent
means that the compilers are close to C++ standard conforming (gcc 4.x).

LyX makes great use of C++ Standard Template Library (STL).
This means that gcc users will have to install the relevant libstdc++
library to be able to compile this version of LyX. 

For full LyX usability we suggest to use at least Qt 4.6 which has been
widely tested. For compilation you need to compile against at least
Qt 4.2.2. The only special point to make is that you must ensure that both
LyX and the Qt libraries are compiled with the same C++ compiler.

To build LyX with spell checking capabilities included you have to
install at least one of the development packages of the spell checker
libraries. See the RELEASE-NOTES for details.


* Other things to note

If you make modifications to files in src/ (for example by applying a
patch), you will need to have the GNU gettext package installed, due
to some dependencies in the makefiles. You can get the latest version
from:
	ftp://ftp.gnu.org/gnu/gettext/

The two following programs should be available at configuration time:

  o LaTeX2e should be correctly setup for the user you are logged in
    as. Otherwise, LyX will not be able to run a number of tests. Note
    that users can run these tests manually with Tools>Reconfigure.

  o Python 2.4 or newer must be installed. Python is used for many
    simple tasks that are executed by external scripts, such as the
    automatic configuration step and the import of older LyX documents
    with the lyx2lyx script (this script is called automatically when
    opening a file). Python 3.0 or later is not supported.


Creating the Makefile
---------------------

LyX can be configured using GNU autoconf utility which attempts to guess
the configuration needed to suit your system.  The standard way to use it
is described in the file INSTALL.autoconf.  In most cases you will be able
to create the Makefile by typing

  ./configure

For more complicated cases, LyX configure honors the following specific
flags:

  o --enable-build-type=[rel(ease), pre(release), dev(elopment), prof(iling), gprof]
    allows to tweak the compiled code. The following table describes
    the settings in terms of various options that are described later

                      release   prerelease  development profiling gprof
    optimization        -O2         -O2         -O         -O2     -O2
    assertions                       X           X
    stdlib-debug                                 X
    concept-checks                   X           X
    warnings                         X           X
    debug                            X           X           X       X
    gprof                                                            X

    The default are as follows in terms of version number
    release: stable release (1.x.y)
    prerelease: version number contains alpha, beta, rc or pre.
    development: version number contains dev.

  o --with-extra-lib=DIRECTORY that specifies the path where LyX will
    find extra libraries (qt4) it needs. Defaults to NONE
    (i.e. search in standard places). You can specify several
    directories, separated by colons.

  o --with-extra-inc=DIRECTORY that gives the place where LyX will find
    extra headers.  Defaults to NONE (i.e.  search in standard places).
    You can specify several directories, separated by colons.

  o --with-extra-prefix[=DIRECTORY] that is equivalent to
       --with-extra-lib=DIRECTORY/lib --with-extra-inc=DIRECTORY/include
    If DIRECTORY is not specified, the current prefix is used.

  o --with-version-suffix[=SUFFIX] will install LyX as lyxSUFFIX. The
    LyX data directory will be something like <whatever>/lyxSUFFIX/.
    Additionally your user configuration files will be found in e.g.
    $HOME/.lyxSUFFIX. The default for SUFFIX is "-<currentversion>",
    e.g. lyx-1.6.1.

    You can use this feature to install more than one version of LyX
    on the same system. You can optionally specify a "version" of your
    own, by doing something like :
       ./configure --with-version-suffix=-latestdev

    Note that the standard configure options --program-prefix,
    --program-suffix and the others will not affect the shared LyX
    directory etc. so it is recommended that you use --with-version-suffix
    (or --prefix) instead.

There are also flags to control the internationalization support in
LyX:

  o --disable-nls suppresses all internationalization support,
    yielding a somewhat smaller code.

  o --with-included-gettext forces the use of the included GNU gettext
    library, although you might have another one installed.

  o --with-catgets allows to use the catget() functions which can
    exist on your system.  This can cause problems, though. Use with
    care.

  o You can also set the environment variable LINGUAS to a list of
    language in case you do not want to install all the translation
    files. For example, if you are only interested in German and
    Finnish, you can type (with sh or bash)
        export LINGUAS='de fi'
    before running configure.

Moreover, the following generic configure flags may be useful:

  o --prefix=DIRECTORY specifies the root directory to use for
    installation. [defaults to /usr/local]

  o --datadir=DIRECTORY gives the directory where all extra LyX
    files (documentation, templates and layout definitions)
    will be installed.
    [defaults to ${prefix}/share/lyx${program_suffix}]

  o --bindir=DIRECTORY gives the directory where the lyx binary
    will be installed. [defaults to ${prefix}/bin]

  o --mandir=DIRECTORY gives the directory where the man pages will go.
    [defaults to ${prefix}/man]

  o --enable-maintainer-mode enables some code that automatically
    rebuilds the configure script, makefiles templates and other useful
    files when needed. This is off by default on releases, to avoid
    surprises.

Note that the --with-extra-* commands are not really robust when it
comes to use of relative paths.  If you really want to use a relative path
here, you can prepend it with "`pwd`/".

If you do not like the default compile flags used (-g -O2 on gcc), you can
set CXXFLAGS variable to other values as follows:

  o CXXFLAGS='-O2' (sh, bash)
  o setenv CXXFLAGS '-O2' (csh, tcsh)

Similarly, if you want to force the use of some specific compiler, you can
give a value to the CXX variable.

If you encounter problems, please read the section 'Problems' at the end of
this file.

The following options allow to tweak more precisely the generated code:

  o --enable-gprof instruments the code for use with the gprof
    profiler. The result are only meaningful in conjunction with
    --enable-build-type=release.

  o --enable-optimization=VALUE enables you to set optimization to a
    higher level as the default (-O), for example --enable-optimization=-O3.

  o --disable-optimization - you can use this to disable compiler
    optimization of LyX. The compile may be much quicker with some
    compilers, but LyX will run more slowly.

  o --enable-debug will add debug information to your binary. This
    requires a lot more disk space, but is a must if you want to try to
    debug problems in LyX. The default is to have debug information
    for development versions and prereleases only.

  o --enable-warnings that make the compiler output more warnings during
    the compilation of LyX.  Opposite is --disable-warnings.  By default,
    this flag is on for development versions only.

  o --enable-assertions that make the compiler generate run-time
    code which checks that some variables have sane values. Opposite
    is --disable-assertions.  By default, this flag is on for
    development versions only.

  o --enable-stdlib-debug adds some debug code in the standard
    library; this slows down the code, but has been helpful in the
    past to find bugs. By default, this flag is on for development
    versions only.

  o --enable-concept-checks adds some compile-time checks. There is no
    run-time penalty. By default, this flag is on for development
    versions only.

  o --without-latex-config that disables the automatic detection of your
    latex configuration.  This detection is automatically disabled if
    latex cannot be found.  If you find that you have to use this
    flag, please report it as a bug.

  o --with-frontend=FRONTEND that allows to specify which frontend you
    want to use. The default value is qt4, which is the only available
    frontend for now.

  o --enable-monolithic-build[=boost,client,insets,mathed,core,tex2lyx,frontend-qt4]
    that enables monolithic build of the given parts of the source
    code. This should reduce the compilation time provided you have
    enough memory (>500MB).


Compiling and installing LyX
----------------------------

Once you've got the Makefile created, you just have to type:

  make all
  make install

All should be OK ;)

Since the binaries with debug information tend to be huge (although
this does not affect the run-time memory footprint), you might want
to strip the lyx binary. In this case replace "make install" with

  make install-strip

BTW: in the images subdirectory there is also a small icon "lyx.png",
that can be used to display lyx-documents in filemanagers.

If configure fails for some strange reason
------------------------------------------

Even when configure fails, it creates a Makefile.  You always can check
the contents of this file, modify it and run 'make'.

Compiling For Multiple Architectures
------------------------------------

You can compile LyX for more than one kind of computer at the same
time, by placing the object files for each architecture in their own
directory.  To do this, you must use a version of `make' that supports
the `VPATH' variable, such as GNU `make'.  `cd' to the directory where
you want the object files and executables to go and run the
`configure' script.  `configure' automatically checks for the source
code in the directory that `configure' is in and in `..'.

If you have to use a `make' that does not supports the `VPATH'
variable, you have to compile LyX for one architecture at a time in
the source code directory.  After you have installed LyX for one
architecture, use `make distclean' before reconfiguring for another
architecture.

Problems
--------

This section provides several hints that have been submitted by LyX
team member or users to help compiling on some particular
architectures. If you find that some of this hints are wrong, please
notify us.

  o On SUN Sparc Solaris, you need gnumake. The LyX makefiles do not
    work with Solaris make.

    The Solaris 8 ar seg-faults trying to build the insets library. You
    will need to use the ar from the GNU binutils for this subdirectory.
    There is no problem with the Solaris 9 and 10 ar.

    Qt4 uses the Xrender X11 extension for antialiased fonts. This
    extension was added to Xsun starting from the Solaris 10 8/07
    release, but it is not activated by default. To activate it, you
    must issue (as root) the following command:
    svccfg -s svc:/application/x11/x11-server setprop options/server_args=+xrender
    and then restart the X server.

    There is a problem with the fontconfig library shipped with
    Solaris 10 8/07 causing a seg-fault when it is used by Qt4.
    Until this is fixed, a workaround is replacing the shared library
    /usr/lib/libfontconfig.so.1 with a copy from a previous release or
    installing a new version of fontconfig from http://www.sunfreeware.com/

    On Solaris, the default fontconfig configuration gives preference
    to bitmap fonts at (not so small) sizes. As bitmapped fonts are not
    antialiased, you may prefer changing this configuration. This may be
    done by adding the following stanza

          <match target="pattern">
              <edit name="prefer_bitmap">
                  <bool>false</bool>
              </edit>
          </match>

    to either ~/.fonts.conf (for a per-user change) or /etc/fonts/local.conf
    (for a global system change). The stanza should be added between the
    <fontconfig> and </fontconfig> tags. If neither ~/.fonts.conf nor
    /etc/fonts/local.conf exist, you can create them with the following
    content:

      <?xml version="1.0"?>
      <!DOCTYPE fontconfig SYSTEM "fonts.dtd">
      <fontconfig>
          <match target="pattern">
              <edit name="prefer_bitmap">
                  <bool>false</bool>
              </edit>
          </match>
      </fontconfig>

